# Copyright 2005 Robert W. Brewer <rwb123 at gmail dot com>
# All Rights Reserved.
#
# This file is part of SpeechLion.
#
# SpeechLion is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# SpeechLion is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with SpeechLion; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#


from java.util import Locale
from javax.speech import Central
from javax.speech import EngineList
from javax.speech import Engine

from javax.speech.synthesis import SynthesizerModeDesc
from javax.speech.synthesis import Synthesizer
from javax.speech.synthesis import SynthesizerProperties
from javax.speech.synthesis import Voice



class TTS:
    def __init__(self, voiceName='kevin16'):
        desc = SynthesizerModeDesc(None, 'general', Locale.US, None, None)
        synthesizer = Central.createSynthesizer(desc)
        if not synthesizer:
            raise RuntimeError, 'FreeTTS not working'
        
        synthesizer.allocate()
        synthesizer.resume()

        desc = synthesizer.getEngineModeDesc()
        voices = desc.getVoices()

        voice = None
        for v in voices:
            if v.getName() == voiceName:
                voice = v
                break
            
        assert voice

        synthesizer.getSynthesizerProperties().setVoice(voice)
        self.synthesizer = synthesizer

    def __del__(self):
        self.synthesizer.deallocate()

    def say(self, text):
        self.synthesizer.speakPlainText(text, None)

    def wait(self):
        self.synthesizer.waitEngineState(Synthesizer.QUEUE_EMPTY)

